<?php

class general
{
    public $sql;
    public $curl;

    public function __construct()
    {
        $this->sql = new sql();
        $this->curl = new cURL();
    }

    public function getCompanyOne($companyID = COMPANY)
    {
        $values = ["company_id" => $companyID];
        return ($this->curl->simple("companies/getOne", $values));
    }

    public function getPaymentMethodsAll($companyID = COMPANY)
    {
        $values = array("company_id" => $companyID);
        return ($this->curl->simple("paymentMethods/getAll", $values));
    }

    public function getMaturityDatesAll($companyID = COMPANY)
    {
        $values = array("company_id" => $companyID);
        return ($this->curl->simple("maturityDates/getAll", $values));
    }

    public function getTaxesAll($companyID = COMPANY)
    {
        $values = array("company_id" => $companyID);
        return ($this->curl->simple("taxes/getAll", $values));
    }

    public function getMeasurementUnitsAll($companyID = COMPANY)
    {
        $values = array("company_id" => $companyID);
        return ($this->curl->simple("measurementUnits/getAll", $values));
    }

    public function getDocumentSetsAll($companyID = COMPANY)
    {
        $values = array("company_id" => $companyID);
        return ($this->curl->simple("documentSets/getAll", $values));
    }

    public function getDocumentsAll($companyID = COMPANY)
    {
        $values = array("company_id" => $companyID);
        return ($this->curl->simple("documents/getAll", $values));
    }

    public function getCountriesAll($companyID = COMPANY)
    {
        $values = array("company_id" => $companyID);
        return ($this->curl->simple("countries/getAll", $values));
    }

    public function getLanguagesAll($companyID = COMPANY)
    {
        $values = array("company_id" => $companyID);
        return ($this->curl->simple("languages/getAll", $values));
    }

    public function getDocumentsOne($values, $companyID = COMPANY)
    {
        $values['company_id'] = $companyID;
        return ($this->curl->simple("documents/getOne", $values));
    }

    public function getPDFLink($values, $companyID = COMPANY)
    {
        $values['company_id'] = $companyID;
        return ($this->curl->simple("documents/getPDFLink", $values));
    }

    public function getDocumentSetsOne($docSet = DOCUMENT_SET_ID, $companyID = COMPANY)
    {
        $docType = false;
        $values = array("company_id" => $companyID);
        $result = $this->curl->simple("documentSets/getAll", $values);

        foreach ($result as $set) {
            if ($set['document_set_id'] == $docSet) {
                if ($set['for_invoice_receipt'] == 1) {
                    $docType = "invoiceReceipts";
                } else {
                    $docType = "invoices";
                }
            }
        }

        return ($docType);
    }

}

$general = new general();
