﻿<?php

$default['taxaIVA'] = 23;

// Correr esta instrução para adicionar o campo com a data de modificação do artigo no Moloni
// Alterando o [DB_PREFIX]
// -> ALTER TABLE `[DB_PREFIX]_product`  ADD `moloni_modified` varchar(250) DEFAULT NULL

require("../../../config.php");
require("assets/class/error.class.php");
require("assets/class/sql.class.php");
require("assets/class/curl.class.php");
require("assets/class/start.class.php");

$start = new start();
$extra = new extra();
if ($start->gtg) {
    require("assets/class/oc.class.php");
    require("assets/class/meth.general.php");
    require("assets/class/meth.entities.php");
    require("assets/class/meth.products.php");
    require("assets/class/meth.documents.php");

    $company = $general->getCompanyOne();
    $sql = new sql();
    $oc = new oc();
    $products = new products();
    $curl = new cURL();

    echo "<b>Actualizar Artigos</b><br><br>";
    $result = $sql->getAll("SELECT * FROM `" . DB_PREFIX . "product` ORDER BY moloni_modified ASC LIMIT 0, 50 ");

    foreach ($result as $product) {
        $exists = false;

        $product_description = $sql->getAll(
            "SELECT * FROM `" . DB_PREFIX . "product_description` WHERE product_id = '" . $product['product_id'] . "' AND language_id = '" . LANG_ID . "'"
        );

        /*********** Definir Referência ***********/
        // Utilizado o Sku
        // Caso não tenha SKU, usa o Model
        // Caso não tenha o Model, é usado o Product_id em formato XX1

        $reference = $product['sku'];

        if (trim($reference) == '') {
            if (trim($product['model']) <> '') {
                $reference = PRODUCT_PREFIX . $product['model'];
            } else {
                $reference = PRODUCT_PREFIX . mb_str_pad($product['product_id'], 3, '0', STR_PAD_LEFT);
            }
        }

        $reference = mb_substr($reference, 0, 20);
        /*********** Definir Referência ***********/

        /*********** Verficar se existe no Moloni ***********/
        $existsCheck = $products->getProductsByRef($reference);

        if (count($existsCheck) > 0) {
            foreach ($existsCheck as $prod) {
                if (strtolower($prod['reference']) == strtolower($reference)) {
                    $exists = true;
                    $productID = $prod['product_id'];
                }
            }
        }
        /*********** Verificar se existe no Moloni ***********/

        if (!$exists) {
            /*********** Caso não exista, vai ser inserido ***********/
            $values['category_id'] = $oc->categoryCheck($product['product_id']);
            $values['type'] = "1";
            $values['name'] = $product_description[0]['name'];
            $values['summary'] = "";
            $values['reference'] = $reference;
            $values['ean'] = "";
            $values['price'] = $product['price'];
            $values['unit_id'] = MEASURE_UNIT;
            $values['has_stock'] = "1";
            $values['stock'] = $product['quantity'];
            $values['pos_favorite'] = "0";
            $values['at_product_category'] = "M";
            $values['taxes'][0]['tax_id'] = $oc->getTaxID($default['taxaIVA']);
            $values['taxes'][0]['value'] = $product['price'] * ($default['taxaIVA'] / 100);
            $values['taxes'][0]['order'] = "1";
            $values['taxes'][0]['cumulative'] = "0";

            $result = $products->insertProduct($values);

            if (!isset($result['product_id'])) {
                echo "<br><b>Erro ao inserir artigo</b>:" . $reference . " - " . $product_description[0]['name'];;
                echo "<pre>";
                print_r($result);
                print_r($values);
                echo "</pre>";
            } else {
                echo "<br><b>Produto inserido</b>: " . $reference . " - " . $product_description[0]['name'];
                $productID = $result['product_id'];
            }
            /*********** Caso não exista, vai ser inserido ***********/
        } else {
            /*********** Caso exista, vai ser actualizado ***********/
            $values['company_id'] = COMPANY;
            $values['product_id'] = $productID;
            $values['name'] = $product_description[0]['name'];
            $values['price'] = $product['price'];
            $values['stock'] = $product['quantity'];
            $values['at_product_category'] = "M";

            $result = $products->insertProduct($values);


            $result = $curl->simple("products/update", $values);
            if (!isset($result['product_id'])) {
                echo "<br><b>Erro ao actualizar artigo</b>: " . $reference . " - " . $product_description[0]['name'];;
                echo "<pre>";
                print_r($result);
                print_r($values);
                echo "</pre>";
            } else {
                echo "<br><b>Produto actualizado</b>: " . $reference . " - " . $product_description[0]['name'];
                $productID = $result['product_id'];
            }
            /*********** Caso exista, vai ser actualizado ***********/
        }

        sleep(0.5);
        $sql->command(
            "UPDATE `" . DB_PREFIX . "product` SET moloni_modified = '" . microtime(
                true
            ) . "' WHERE product_id = '" . $product['product_id'] . "'"
        );
    }
}


?>
